$APPTYPE   GUI
$ESCAPECHARS ON
$INCLUDE "RAPIDQ.INC"
$OPTIMIZE ON
$TYPECHECK ON
$INCLUDE "C:\Temporary\Blastgraph\QChartnew.inc"

DECLARE SUB ClearGraphs
DECLARE SUB TabChange
DECLARE SUB frmMainResize (SENDER AS QForm)
DECLARE SUB mabout
DECLARE SUB mserial
DECLARE SUB ComError(strErrorMessage AS STRING)
DECLARE SUB PortOpen
DECLARE SUB PortClosed
DECLARE SUB StringWritten
DECLARE SUB StringRead
DECLARE SUB readserialinputbuffer
DECLARE SUB StripPacket
DECLARE SUB graphstuff

DECLARE FUNCTION calccrc(packet AS STRING) AS STRING

CONST GWL_HWNDPARENT = (-8)                         'Minimize to task bar
CONST HWND_DESKTOP = 0
DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA"_
                 (hwnd AS LONG, nIndex AS LONG, dwNewLong AS LONG) AS LONG
                                                   
DIM i  AS INTEGER                                 'Loop counters...
DIM h  AS INTEGER
DIM x  AS INTEGER
DIM graphtestvalue AS INTEGER
DIM graphnum AS INTEGER
DIM BytesRead AS DWORD
DIM BytesInBuffer AS DWORD
DIM serialinstring AS STRING
DIM packet AS STRING
DIM errorlogmsg AS STRING
DIM packetcommand AS INTEGER
DIM packettime AS STRING
DIM manipstring AS STRING
DIM packetdata AS INTEGER

CREATE portchecktimer AS QTimer
  Interval = 1
  Enabled = 1
  OnTimer = graphstuff 
END CREATE

CREATE frmMain AS QForm
'  Center
  Height = 480
  Width = 640  
'  Windowstate = 2
  Caption = "Blast Graph"
  create mainmnu as qmainmenu
    create filemnu as qmenuitem
      caption = "&File"
            create mnunew as qmenuitem
        caption = "&Clear"
'        shortcut = "Ctrl+N"
'        onclick = mnew
      end create
      create mnusave as qmenuitem
        caption = "&Save"
'        shortcut = "Ctrl+S"
'        onclick = msave
      end create
      create mnubreak1 as qmenuitem
        caption = "-"
      end create
      create mnuprint as qmenuitem
        caption = "Print"
'        shortcut = "Ctrl+P"
      end create
      create mnubreak2 as qmenuitem
        caption = "-"
      end create
      create mnuexit as qmenuitem
        caption = "E&xit"
'        shortcut = "Alt+F4"
'        onclick = mexit
      end create
    end create
  
    create optionsmnu as qmenuitem
      caption = "&Options"
      create mnuserial as qmenuitem
        caption = "&Serial Setup"
        onclick = mserial
      end create
    end create
      
    create helpmnu as qmenuitem
      caption = "&Help"
      create mnuabout as qmenuitem
        caption = "&About Blast Graph"
        onclick = mabout
      end create
    end create
  end create

  CREATE StatusBar AS QSTATUSBAR
    Height    = 20
    SizeGrip  = FALSE
    AddPanels "Panel 1", "Panel 2"
    Panel(0).Caption = "Not Connected"
    Panel(0).Width = 400
    Panel(1).Caption = ""
  END CREATE

  CREATE Tab AS QTabControl  
    AddTabs "Door Vac","Chamber Vac","Oxygen Conc","Heater Temp","Chamber Temp"
    Align = alClient
    OnChange = TabChange
    HotTrack = True
    CREATE graph1 AS QChart
      Align = alClient
      OnPaint = graph1.PaintChart
'      ChartType = ctReal
    END CREATE
    CREATE graph2 AS QChart
      Align = alClient
      OnPaint = graph2.PaintChart
'      ChartType = ctReal
    END CREATE
    CREATE graph3 AS QChart
      Align = alClient
      OnPaint = graph3.PaintChart
'      ChartType = ctReal
    END CREATE
    CREATE graph4 AS QChart
      Align = alClient
      OnPaint = graph4.PaintChart
'      ChartType = ctReal
    END CREATE
    CREATE graph5 AS QChart
      Align = alClient
      OnPaint = graph5.PaintChart
'      ChartType = ctReal
    END CREATE
  END CREATE
END CREATE  

setwindowlong(frmMain.handle, GWL_HWNDPARENT, HWND_DESKTOP)
setwindowlong(application.handle, GWL_HWNDPARENT, frmMain.handle)

ClearGraphs
frmMain.OnResize = frmMainResize
frmMain.ShowModal

SUB ClearGraphs
  WITH graph1
    .Initialize                                     'Set defaults 
    .ChartType = ctReal                             'Real TimeGraph
    .DoLegend = False
    .XTitle.Text = "Time (min)"
    .YTitle.Text = "mTorr"
    .series(1).linewidth = 2
    .xaxis.grid = false
    .bgColor = RGB(130,135,180)
    .PlotAreaColor = RGB(80,80,80)
    .GridColor = RGB(50,50,50)
    .Series(1).AutoColor = False
    .Series(1).Color = RGB(140,215,140)
    .Viewport = 100
    REDIM PRESERVE (graph3.Data(.Cols,.Rows))    'Redim Data keeping old data
    .SubTitle.Text = "Door Vacuum:  "
    .Data(1,1) = 0                  'Generate a new data point
    .LabelList.Clear
    .LabelList.AddItems "1"                   'Set label text for beginning
    .LabelList.AddItems STR$(.Viewport)       'and end of XAxis
    .DrawChart (FALSE)                          'Draw it!
    .Visible = False
  END WITH
  WITH graph2
    .Initialize                                     'Set defaults 
    .ChartType = ctReal                             'Real TimeGraph
    .DoLegend = False
    .XTitle.Text = "Time (min)"
    .YTitle.Text = "mTorr"
    .series(1).linewidth = 2
    .xaxis.grid = false
    .bgColor = RGB(130,135,180)
    .PlotAreaColor = RGB(80,80,80)
    .GridColor = RGB(50,50,50)
    .Series(1).AutoColor = False
    .Series(1).Color = RGB(255,255,255)
    .Viewport = 100
    REDIM PRESERVE (graph3.Data(.Cols,.Rows))    'Redim Data keeping old data
    .SubTitle.Text = "Chamber Vacuum:  "
    .Data(1,1) = 0                  'Generate a new data point
    .LabelList.Clear
    .LabelList.AddItems "1"                   'Set label text for beginning
    .LabelList.AddItems STR$(.Viewport)       'and end of XAxis
    .DrawChart (FALSE)                          'Draw it!
    .Visible = False
  END WITH
  WITH graph3
    .Initialize                                     'Set defaults 
    .ChartType = ctReal                             'Real TimeGraph
    .DoLegend = False
    .XTitle.Text = "Time (min)"
    .YTitle.Text = "ppm"
    .series(1).linewidth = 2
    .xaxis.grid = false
    .bgColor = RGB(130,135,180)
    .PlotAreaColor = RGB(80,80,80)
    .GridColor = RGB(50,50,50)
    .Series(1).AutoColor = False
    .Series(1).Color = RGB(0,0,255)
    .Viewport = 100
    REDIM PRESERVE (graph3.Data(.Cols,.Rows))    'Redim Data keeping old data
    .SubTitle.Text = "Chamber Oxygen:  "
    .Data(1,1) = 0                  'Generate a new data point
    .LabelList.Clear
    .LabelList.AddItems "1"                   'Set label text for beginning
    .LabelList.AddItems STR$(.Viewport)       'and end of XAxis
    .DrawChart (FALSE)                          'Draw it!
    .Visible = False
  END WITH
  WITH graph4
    .Initialize                                     'Set defaults 
    .ChartType = ctReal                             'Real TimeGraph
    .DoLegend = False
    .XTitle.Text = "Time (min)"
    .YTitle.Text = "C"
    .series(1).linewidth = 2
    .xaxis.grid = false
    .bgColor = RGB(130,135,180)
    .PlotAreaColor = RGB(80,80,80)
    .GridColor = RGB(50,50,50)
    .Series(1).AutoColor = False
    .Series(1).Color = RGB(255,255,0)
    .Viewport = 100
    REDIM PRESERVE (graph3.Data(.Cols,.Rows))    'Redim Data keeping old data
    .SubTitle.Text = "Heater Temperature:  "
    .Data(1,1) = 0                  'Generate a new data point
    .LabelList.Clear
    .LabelList.AddItems "1"                   'Set label text for beginning
    .LabelList.AddItems STR$(.Viewport)       'and end of XAxis
    .DrawChart (FALSE)                          'Draw it!
    .Visible = False
  END WITH
  WITH graph5
    .Initialize                                     'Set defaults 
    .ChartType = ctReal                             'Real TimeGraph
    .DoLegend = False
    .XTitle.Text = "Time (min)"
    .YTitle.Text = "C"
    .series(1).linewidth = 2
    .xaxis.grid = false
    .bgColor = RGB(130,135,180)
    .PlotAreaColor = RGB(80,80,80)
    .GridColor = RGB(50,50,50)
    .Series(1).AutoColor = False
    .Series(1).Color = RGB(255,0,0)
    .Viewport = 100
    REDIM PRESERVE (graph3.Data(.Cols,.Rows))    'Redim Data keeping old data
    .SubTitle.Text = "Chamber Temperature:  "
    .Data(1,1) = 0                  'Generate a new data point
    .LabelList.Clear
    .LabelList.AddItems "1"                   'Set label text for beginning
    .LabelList.AddItems STR$(.Viewport)       'and end of XAxis
    .DrawChart (FALSE)                          'Draw it!
    .Visible = False
  END WITH
END SUB

SUB mabout
  messagebox("Blast Graph Version 0.x (Alpha)\n \n"+_
  "Written by Brandon A. Tarr using Rapid-Q Basic.\n \n"+_
  "This program is property of Restek Corperation.","About Blast Graph",&h40)
END SUB

SUB mserial
  messagebox("Input must be 9600 baud, 8 data bits, no parity, 1 stop bit, on COM4.","Serial input requirements",&h40)
END SUB  

SUB TabChange
  SELECT CASE Tab.TabIndex
    CASE 0
      graph1.Visible = True
      graph1.RedrawChart
      graph2.Visible = False
      graph3.Visible = False
      graph4.Visible = False
      graph5.Visible = False
    CASE 1
      graph1.Visible = False
      graph2.Visible = True
      graph2.RedrawChart
      graph3.Visible = False
      graph4.Visible = False
      graph5.Visible = False
    CASE 2
      graph1.Visible = False
      graph2.Visible = False
      graph3.Visible = True
      graph3.RedrawChart
      graph4.Visible = False
      graph5.Visible = False
    CASE 3
      graph1.Visible = False
      graph2.Visible = False
      graph3.Visible = False
      graph4.Visible = True
      graph4.RedrawChart
      graph5.Visible = False
    CASE 4
      graph1.Visible = False
      graph2.Visible = False
      graph3.Visible = False
      graph4.Visible = False
      graph5.Visible = True
      graph5.RedrawChart
  END SELECT
END SUB

SUB frmMainResize (SENDER AS QForm)
  SELECT CASE Tab.TabIndex
    CASE 0
      graph1.RedrawChart
    CASE 1
      graph2.RedrawChart
    CASE 2
      graph3.RedrawChart
    CASE 3
      graph4.RedrawChart
    CASE 4
      graph5.RedrawChart
  END SELECT
END SUB

SUB graphstuff

          With graph1
            REDIM PRESERVE (graph1.Data(.Cols,.Rows))    'Redim Data keeping old data
            .SubTitle.Text =  "Current graph value:  " & str$(i^1)
            .Data(1,.rows) = i^1                  'Generate a new data point
            .LabelList.Clear
            IF .rows <= .Viewport THEN
              .LabelList.AddItems "1"                   'Set label text for beginning
              .LabelList.AddItems STR$(.Viewport)       'and end of XAxis
            ELSE
              .LabelList.AddItems STR$(.Rows - .Viewport)
              .LabelList.AddItems STR$(.Rows)
            END IF
            IF tab.tabindex = 0 THEN
              .DrawChart (FALSE)                          'Draw it!
            END if
            .rows=.rows+1
          End With

'|          With graph2
'|            REDIM PRESERVE (graph2.Data(.Cols,.Rows))    'Redim Data keeping old data
'|            .SubTitle.Text =  "Current graph value:  " & str$(i^2)
'|            .Data(1,.rows) = i^2                  'Generate a new data point
'|            .LabelList.Clear
'|            IF .rows <= .Viewport THEN
'|              .LabelList.AddItems "1"                   'Set label text for beginning
'|              .LabelList.AddItems STR$(.Viewport)       'and end of XAxis
'|            ELSE
'|              .LabelList.AddItems STR$(.Rows - .Viewport)
'|              .LabelList.AddItems STR$(.Rows)
'|            END IF
'|            IF tab.tabindex = 1 THEN
'|              .DrawChart (FALSE)                          'Draw it!
'|            END if
'|            .rows=.rows+1
'|          End With
'|
'|          With graph3
'|            REDIM PRESERVE (graph3.Data(.Cols,.Rows))    'Redim Data keeping old data
'|            .SubTitle.Text =  "Current graph value:  " & str$(i^3)
'|            .Data(1,.rows) = i^3                  'Generate a new data point
'|            .LabelList.Clear
'|            IF .rows <= .Viewport THEN
'|              .LabelList.AddItems "1"                   'Set label text for beginning
'|              .LabelList.AddItems STR$(.Viewport)       'and end of XAxis
'|            ELSE
'|              .LabelList.AddItems STR$(.Rows - .Viewport)
'|              .LabelList.AddItems STR$(.Rows)
'|            END IF
'|            IF tab.tabindex = 2 THEN
'|              .DrawChart (FALSE)                          'Draw it!
'|            END if
'|            .rows=.rows+1
'|          End With
'|
'|          With graph4
'|            REDIM PRESERVE (graph4.Data(.Cols,.Rows))    'Redim Data keeping old data
'|            .SubTitle.Text = "Current graph value:  " & str$(i^4)
'|            .Data(1,.rows) = i^4                  'Generate a new data point
'|            .LabelList.Clear
'|            IF .rows <= .Viewport THEN
'|              .LabelList.AddItems "1"                   'Set label text for beginning
'|              .LabelList.AddItems STR$(.Viewport)       'and end of XAxis
'|            ELSE
'|              .LabelList.AddItems STR$(.Rows - .Viewport)
'|              .LabelList.AddItems STR$(.Rows)
'|            END IF
'|            IF tab.tabindex = 3 THEN
'|              .DrawChart (FALSE)                          'Draw it!
'|            END if
'|            .rows=.rows+1
'|          End With
'|
'|          With graph5
'|            REDIM PRESERVE (graph5.Data(.Cols,.Rows))    'Redim Data keeping old data
'|            .SubTitle.Text = "Current graph value:  " & str$(i^5)
'|            .Data(1,.rows) = i^5                  'Generate a new data point
'|            .LabelList.Clear
'|            IF .rows <= .Viewport THEN
'|              .LabelList.AddItems "1"                   'Set label text for beginning
'|              .LabelList.AddItems STR$(.Viewport)       'and end of XAxis
'|            ELSE
'|              .LabelList.AddItems STR$(.Rows - .Viewport)
'|              .LabelList.AddItems STR$(.Rows)
'|            END IF
'|            IF tab.tabindex = 4 THEN
'|              .DrawChart (FALSE)                          'Draw it!
'|            END if
'|            .rows=.rows+1
'|          End With
i=i+1

END SUB
